program fence_petr;

{$APPTYPE CONSOLE}
{$R+,Q+,S+,H+}

uses
  Math, SysUtils;

Const
  TaskID='fence';
  InFile=TaskID+'.in';
  OutFile=TaskID+'.out';
  MaxN=1000;
  MaxM=40;
  MaxC=1000000;
  Infinity=MaxLongInt;

Var
  N,M:Integer;
  Res:Integer;
  Cur,S:String;
  A,C:Array[1..MaxM]Of Integer;
  Best:Array[-MaxN..MaxN]Of Integer;

Procedure Load;
Var
  I:Integer;
Begin
  ReSet(Input,InFile);
  ReadLn(N,M);
  Assert((N>=1) And (N<=MaxN));
  Assert((M>=1) And (M<=MaxM));
  ReadLn(S);
  Assert(Length(S)=N);
  For I:=1 To N Do Assert(S[I] In ['0','+']);
  For I:=1 To M Do Begin
    ReadLn(A[I],C[I]);
    Assert((A[I]>=1) And (A[I]<=N) And (C[I]>=1) And (C[I]<=MaxC));
  End;
  Close(Input);
End;

Procedure Solve;
Var
  Split:Integer;
  I,J:Integer;
Begin
  Res:=Infinity;
  For Split:=1 To N Do Begin
    Cur:=Copy(S,Split,Length(S))+Copy(S,1,Split-1);
    FillChar(Best,SizeOf(Best),0);
    For I:=1 To N Do Begin
      Best[I]:=Infinity;
      If Cur[I]='+' Then Best[I]:=Min(Best[I],Best[I-1]);
      For J:=1 To M Do
        Best[I]:=Min(Best[I],Best[I-A[J]]+C[J]);
    End;
    Res:=Min(Res,Best[N]);
  End;
End;

Procedure Save;
Begin
  ReWrite(Output,OutFile);
  WriteLn(Res);
  Close(Output);
End;

begin
  Load;
  Solve;
  Save;
end.
