#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "burrow"

const int MinN = 1, MaxN = 1000;

int a [MaxN], b [MaxN], c [MaxN], q [MaxN], r [MaxN];
bool d [MaxN];

int main (void)
{
 int i, n, x, y, t;
 int qb, qe;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d %d %d", &n, &x, &y) != EOF)
 {
  assert (n >= MinN && n <= MaxN);
  assert (x >= MinN && x <= n);
  assert (y >= MinN && y <= n);
  x--, y--;
  for (i = 0; i < n; i++)
  {
   scanf (" %d %d %d", &a[i], &b[i], &c[i]);
   a[i]--, b[i]--, c[i]--;
  }
  for (i = 0; i < n; i++)
  {
   assert (a[i] != b[i] && b[i] != c[i]);
   assert (a[a[i]] == i || b[a[i]] == i || c[a[i]] == i);
   assert (a[b[i]] == i || b[b[i]] == i || c[b[i]] == i);
   assert (a[c[i]] == i || b[c[i]] == i || c[c[i]] == i);
  }
  memset (r, -1, sizeof (r));
  memset (d, 0, sizeof (d));
  qb = qe = 0;
  q[qe] = x, r[x] = 0, d[x] = true, qe++;
  while (qb < qe)
  {
   x = q[qb], t = r[x] + 1, qb++;
   if (x == y) break;
   q[qe] = a[x], r[a[x]] = t, d[a[x]] = true, qe++;
   q[qe] = b[x], r[b[x]] = t, d[b[x]] = true, qe++;
   q[qe] = c[x], r[c[x]] = t, d[c[x]] = true, qe++;
  }
  printf ("%d\n", r[y]);
 }
 return 0;
}
