import java.util.*;
import java.io.*;

public class euclid_ft implements Runnable {

	Scanner in;
	PrintWriter out;

	private void myAssert(boolean e) {
		if (!e) {
			throw new Error("Assertion failure!!!");
		}
	}

	class Phase {
		long a0, b0;
		long a, b;

		public Phase(long a0, long b0, long a, long b) {
			this.a0 = a0;
			this.b0 = b0;
			this.a = a;
			this.b = b;
		}

		public boolean check(long c, long d) {
			return (d == b0) && (c <= a0) && ((c - (a0 % b0)) % b0 == 0);
		}

	}

	ArrayList<Phase> pl; 
    
    public long euclid(long a, long b) {
    	if (a < b) {
    		pl.add(new Phase(a, b, b, a));
    		long t = a;
    		a = b;
    		b = t;
    	}
    	if (b == 0) return a;
    	pl.add(new Phase(a, b, b, a % b));
    	return euclid(b, a % b);
    }

	private void solve(long a, long b, long c, long d) {
		myAssert(1 <= a && a <= 1000000000000000000l);
		myAssert(1 <= b && b <= 1000000000000000000l);
		myAssert(1 <= c && c <= 1000000000000000000l);
		myAssert(1 <= d && d <= 1000000000000000000l);
		pl = new ArrayList<Phase>();
		euclid(a, b);
		for (Phase p : pl) {
			if (p.check(c, d)) {
				out.println("YES");
				return;
			}
		}

		out.println("NO");

	}

	private void solve() {
		int k = in.nextInt();
		for (int i = 0; i < k; i++) {
			solve(in.nextLong(), in.nextLong(), in.nextLong(), in.nextLong());
		}
	}

	public void run() {
		try {
			solve();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		} finally {
			out.close();
		}
	}

	public euclid_ft(String taskName) {
		try {
			in = new Scanner(new File(taskName + ".in"));
			out = new PrintWriter(new File(taskName + ".out"));
		} catch (IOException ioe) {
			ioe.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		(new Thread(new euclid_ft("euclid"))).start();
	}

}