#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "section"

const int MinN = 1, MaxN = 1000, Base = 10;
typedef int bignum [MaxN];

void add (bignum & a, const bignum & b, const bignum & c)
{
 int i, l, p;
 l = (b[0] > c[0]) ? b[0] : c[0];
 p = 0;
 for (i = 1; i <= l; i++)
 {
  p += b[i] + c[i];
  if (p >= Base) a[i] = p - Base, p = 1;
            else a[i] = p, p = 0;
 }
 if (p) a[++l] = 1;
 a[0] = l;
}

void outbln (const bignum & a)
{
 int i;
 printf ("%d", a[a[0]]);
 for (i = a[0] - 1; i >= 1; i--)
  printf ("%d", a[i]);
 printf ("\n");
}

bignum f [2];

int main (void)
{
 int i, n;
 int b;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d", &n) != EOF)
 {
  assert (n >= MinN && n <= MaxN);
  memset (f, 0, sizeof (f));
  f[0][0] = f[0][1] = 1;
  b = 0;
  for (i = 0; i < n; i++)
  {
   b = !b;
   add (f[b], f[b], f[!b]);
  }
  outbln (f[b]);
  outbln (f[!b]);
 }
 return 0;
}
