#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <queue>

using namespace std;

const int MaxN = 1000;

int a[MaxN + 1][3];
int step[MaxN + 1];
bool visited[MaxN + 1];

void bfs(int start)
{
	memset(visited, 0, sizeof(visited));
	memset(step, 0, sizeof(step));
	queue<int> q;
	q.push(start);
	visited[start] = true;
	while (!q.empty())
	{
		int v = q.front();
		q.pop();
		for (int i = 0; i < 3; i++)
			if (!visited[a[v][i]])
			{
				step[a[v][i]] = step[v] + 1;
				visited[a[v][i]] = true;
				q.push(a[v][i]);
			}
	}
}

int main()
{
	freopen("burrow.in", "r", stdin);
	freopen("burrow.out", "w", stdout);
	int n, x, y;
	scanf("%d%d%d", &n, &x, &y);
	for (int i = 1; i <= n; i++)
	{
		scanf("%d%d%d", &a[i][0],
			&a[i][1], &a[i][2]);
	}
	bfs(x);
	if (!visited[y])
		printf("-1\n");
	else
		printf("%d\n", step[y]);
	return 0;
}
